﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TreeViewRightMouseSelect
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ContextMenu cm = null;
        DataItems dataitems;
        public MainWindow()
        {
            InitializeComponent();
            cm = new ContextMenu();
            MenuItem mi = new MenuItem();
            mi.Header = "Hi";
            mi.Click += Mi_Click;
            cm.Items.Add(mi);
            MenuItem mi1 = new MenuItem();
            mi1.Header = "HEllo";
            mi1.Click += Mi_Click;
            cm.Items.Add(mi1);
            treeview.ContextMenu = cm;
            dataitems = new DataItems();
            treeview.ItemsSource = dataitems.Items;
            treeview.DisplayMemberPath = "Name";
           // treeview.Items[0].i
        }

        private void Mi_Click(object sender, RoutedEventArgs e)
        {
            if (treeview.SelectedItem != null)
            {
                (treeview.SelectedItem.DataContext as Item).Name = "Text";
            }            
        }

        private void C1TreeView_MouseRightButtonDown(object sender, MouseButtonEventArgs e)
        {           
            Point p = e.GetPosition(treeview);
            var ControlType = treeview.InputHitTest(p);
            if (!(ControlType is Border))
            {
                var node = treeview.GetNode(p);
                node.IsSelected = true;
                dataitems.MySelectedItem = node.DataContext as Item;
            }
        }
    }

    public class DataItems : INotifyPropertyChanged
    {
        private Item _selectedItem = null;
        private ObservableCollection<Item> _items = new ObservableCollection<Item>();
         public DataItems()
        {
            Items.Add(new Item()
            {
                Name = "E"
            });
            Items.Add(new Item()
            {
                Name = "F"
            });
            Items.Add(new Item()
            {
                Name = "G"
            });
        }
        public ObservableCollection<Item> Items
        {
            get
            {
              
                return _items;
            }
        }
        public Item MySelectedItem
        {
            get
            {
                return _selectedItem;
            }
            set
            {
                if (_selectedItem != value)
                {
                    this._selectedItem = value;
                    NotifyPropertyChanged("MySelectedItem");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    public class Item : INotifyPropertyChanged
    {
        private string _name = "";
        public string Name {
            get
            {
                return _name;
            }
            set
            {
                if (_name!= value)
                {
                    _name = value;
                    NotifyPropertyChanged("Name");
                }
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

    }

}
